            #GIT_CMT=4edcad45ec05bc08099cfb55eb55bfc48bff2b80
#
# Spec file for ocfs2-tools
#

# Macros
# This one is hardcoded because, well, it belongs there
%define _prefix /usr
# Because RPM is dumb
%define _unpackaged_files_terminate_build 0
# Because RH defines lib64 on ppc32 builds
%ifarch ppc
%define brokenrhlibdir /usr/lib
%else
%define brokenrhlibdir %{_libdir}
%endif


%define build_ocfs2console	0
%define compile_py		0
%define systemd_enabled	0

%if %{build_ocfs2console}
%define compile_py		1
%endif

Summary: Tools for managing the Oracle Cluster Filesystem 2
Name: ocfs2-tools
Version: 1.8.6
Release:    11.el6
License: GPL
Group: System Environment/Kernel
Source: ocfs2-tools-1.8.6.tar.bz2
URL: http://oss.oracle.com/projects/ocfs2-tools/
Distribution: Oracle
Vendor: Oracle
Packager: nobody <nobody@oracle.com>
Exclusiveos: Linux
Requires: bash, which, coreutils, net-tools, e2fsprogs, chkconfig, glib2 >= 2.2.3, util-linux >= 2.12j, modutils
BuildRequires: e2fsprogs-devel, glib2-devel >= 2.2.3, pygtk2 >= 1.99.16, python-devel >= 2.6, util-linux >= 2.12j,

BuildRoot: %{_tmppath}/ocfs2-tools-%{PACKAGE_VERSION}-%{PACKAGE_RELEASE}-root
%if !%{build_ocfs2console}
Obsoletes: ocfs2console
%endif

%description
Tools to manage Oracle Cluster Filesystem 2 volumes.

%if %{build_ocfs2console}
%package -n ocfs2console
Summary: GUI frontend for OCFS2 management
Group: System Environment/Kernel
Requires: e2fsprogs, glib2 >= 2.2.3, vte >= 0.11.10, pygtk2 >= 1.99.16, python >= 2.6, ocfs2-tools = %{version}
AutoReqProv: No


%description -n ocfs2console
GUI frontend for management and debugging of Oracle Cluster Filesystem 2
volumes.
%endif



%package -n ocfs2-tools-devel
Summary: Headers and static archives for ocfs2-tools
Group: Development/Libraries
Requires: e2fsprogs-devel, glib2-devel >= 2.2.3, ocfs2-tools = %{version}
AutoReqProv: No

%description -n ocfs2-tools-devel
ocfs2-tools-devel contains the libraries and header files needed to
develop ocfs2 filesystem-specific programs.



%prep
%setup -n ocfs2-tools-%{version}


%build
./autogen.sh --prefix=/
%configure --disable-debug --enable-dynamic-ctl --prefix=/usr --mandir=/usr/share/man --libdir=%{brokenrhlibdir}
make


%install

%if %{systemd_enabled}
	mkdir -p $RPM_BUILD_ROOT/usr/lib/systemd/system
	cp -f  vendor/common/o2cb.service $RPM_BUILD_ROOT/usr/lib/systemd/system/
	cp -f  vendor/common/ocfs2.service $RPM_BUILD_ROOT/usr/lib/systemd/system/
	mkdir -p $RPM_BUILD_ROOT/sbin
	cp -f vendor/common/o2cb.init $RPM_BUILD_ROOT/sbin
	cp -f vendor/common/ocfs2.init $RPM_BUILD_ROOT/sbin
%else
	mkdir -p $RPM_BUILD_ROOT/etc/init.d
	cp -f vendor/common/o2cb.init $RPM_BUILD_ROOT/etc/init.d/o2cb
	cp -f vendor/common/ocfs2.init $RPM_BUILD_ROOT/etc/init.d/ocfs2
%endif
if [ -f /etc/redhat-release ]
then
    # Red Hat chkconfig is completely and utterly broken
    perl -p -i -e 'BEGIN() { $k=0;}  if (/^###/) { $k++ } elsif ($k == 1) { printf "#"};' $RPM_BUILD_ROOT/etc/init.d/o2cb
    perl -p -i -e 'BEGIN() { $k=0;}  if (/^###/) { $k++ } elsif ($k == 1) { printf "#"};' $RPM_BUILD_ROOT/etc/init.d/ocfs2
fi
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
cp -f vendor/common/o2cb.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/o2cb

make DESTDIR="$RPM_BUILD_ROOT" install

%if %{compile_py}
%{__python} -c "import compileall; compileall.compile_dir('$RPM_BUILD_ROOT/%{brokenrhlibdir}/python2.6/site-packages/ocfs2interface', ddir='%{brokenrhlibdir}/python2.6/site-packages/ocfs2interface')"
%endif


%clean
rm -rf "$RPM_BUILD_ROOT"


%post
%if !%{systemd_enabled}
	/sbin/chkconfig --add o2cb >/dev/null
	/sbin/chkconfig --add ocfs2 >/dev/null
%else
	# clean up start/kill entry in /etc/rc*.d/ when upgrade.
	if [ -f /etc/init.d/o2cb ]; then
		/sbin/chkconfig --del o2cb >/dev/null
	fi

	if [ -f /etc/init.d/ocfs2 ]; then
		/sbin/chkconfig --del ocfs2 >/dev/null
	fi
%endif

%preun
%if !%{systemd_enabled}
	if [ $1 = 0 ]; then     # execute this only if we are NOT doing an upgrade
		/sbin/chkconfig --del ocfs2 >/dev/null
		/sbin/chkconfig --del o2cb >/dev/null
	fi
%endif

%files
%defattr(-,root,root)
%doc COPYING CREDITS MAINTAINERS
/sbin/fsck.ocfs2
/sbin/mkfs.ocfs2
/sbin/mounted.ocfs2
/sbin/tunefs.ocfs2
/sbin/debugfs.ocfs2
/sbin/o2cb_ctl
/sbin/o2cb
/sbin/mount.ocfs2
/sbin/o2image
/sbin/o2cluster
/sbin/ocfs2_hb_ctl
%if %{systemd_enabled}
/sbin/o2cb.init
/sbin/ocfs2.init
/usr/lib/systemd/system/o2cb.service
/usr/lib/systemd/system/ocfs2.service
%else
/etc/init.d/o2cb
/etc/init.d/ocfs2
%endif
/usr/bin/o2info
/usr/sbin/o2hbmonitor
%config(noreplace) /etc/sysconfig/o2cb
/usr/share/man/man8/debugfs.ocfs2.8.gz
/usr/share/man/man8/fsck.ocfs2.8.gz
/usr/share/man/man8/fsck.ocfs2.checks.8.gz
/usr/share/man/man8/mkfs.ocfs2.8.gz
/usr/share/man/man8/tunefs.ocfs2.8.gz
/usr/share/man/man8/mount.ocfs2.8.gz
/usr/share/man/man8/mounted.ocfs2.8.gz
/usr/share/man/man8/o2cb_ctl.8.gz
/usr/share/man/man8/o2cb.8.gz
/usr/share/man/man8/ocfs2_hb_ctl.8.gz
/usr/share/man/man8/o2image.8.gz
/usr/share/man/man7/o2cb.7.gz
/usr/share/man/man1/o2info.1.gz
/usr/share/man/man8/o2hbmonitor.8.gz
/usr/share/man/man5/ocfs2.cluster.conf.5.gz
/usr/share/man/man5/o2cb.sysconfig.5.gz
/usr/share/man/man7/ocfs2.7.gz
/usr/share/man/man8/o2cluster.8.gz


%if %{build_ocfs2console}
%files -n ocfs2console
%defattr(-,root,root)
%{brokenrhlibdir}/python2.6/site-packages/ocfs2interface
/usr/sbin/ocfs2console
/usr/share/man/man8/ocfs2console.8.gz
%endif

%files -n ocfs2-tools-devel
%defattr(-,root,root)
%{brokenrhlibdir}/*.a
%{brokenrhlibdir}/pkgconfig/*.pc
%{_includedir}/ocfs2-kernel
%{_includedir}/o2cb
%{_includedir}/o2dlm
%{_includedir}/ocfs2



%changelog
* Mon Apr 1 2019 Ashish Samant <ashish.samant@oracle.com> - 1.8.6-11.el6
- tunefs.ocfs2: read journal superblock even for online operations (Ashish
  Samant)  [Orabug: 28804934]

* Fri Mar 08 2019 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-10.el6
- ocfs2-tools: added spec rhel8 for jenkins (Shuning Zhang)  [Orabug: 29292163] 
- ocfs2-tools: added support for rhel8 rpm package build (Shuning Zhang)  [Orabug: 29292163] 
- ocfs2-tools: fix the conflict of gcc option in Makefile (Shuning Zhang)  [Orabug: 29292163] 
- tunefs.ocfs2: fix format security warning (Shuning Zhang)  [Orabug: 29292163] 
- o2image: fix unknown type name 'loff_t' (Shuning Zhang)  [Orabug: 29292163] 
- mounted.ocfs2: use <sys/sysmacros.h> include for makedev (Valentin Vidic)  [Orabug: 29292163] 
- fsck.ocfs2: fix compile error when glibc upgrade (Gang He)  [Orabug: 29292163] 
- ocfs2-libocfs2: fix unknown type name 'loff_t' (Shuning Zhang)  [Orabug: 29292163]

* Fri Dec 23 2016 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-9.el6
- BUILDINFO: commit=8b8e9d3b017f6e9bb23bd137878669831eec0f4d
- o2cb.service: drop unknown lvalue ExecRestart (Junxiao Bi)

* Fri Nov 11 2016 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-8.el6
- BUILDINFO: commit=f0e130273b7eed12385e1d0aa7704b414bceeff0
- vendor: rhel5: fix build failure (Junxiao Bi)  
- tunefs.ocfs2: fix double free bug (Junxiao Bi)  
- fsck.ocfs2: the members of 'o2fsck_state' need to be freed at the end of main() (Jun Piao)  
- fsck.ocfs2: fix the mistake of clearing valid flag in o2fsck_check_blocks() (Jun Piao)  
- mkfs.ocfs2: disable append-dio feature by default (Junxiao Bi)  
- fsck.ocfs2: support append direct io incompat feature (Joseph Qi)  
- tunefs.ocfs2: support append direct io incompat feature (Joseph Qi)  
- mkfs.ocfs2: support append direct io incompat feature (Joseph Qi)  
- mkfs.ocfs2: clean up deadcode in is_cluster_info_valid() (Jun Piao)  
- fsck.ocfs2: return error if o2fsck_check_journals fails (Joseph Qi)  
- ocfs2: fix cluster unlocked if journal is replayed (Joseph Qi)  
- fsck.ocfs2: close ost_fs in case of check superblock fails (Joseph Qi)  
- mkfs.ocfs2: fix a potential segment fault in main() (Jun Piao)  
- fsck.ocfs2: clean up useless assignment in dup_insert() (piaojun)  
- o2info: clean up useless branch in o2info_append_task() (piaojun)  
- tunefs.ocfs2: fix the parameter misuse of tunefs_dlm_lock (Weiwei Wang)  
- debugfs.ocfs2: encode 'M' lockname with generation only for sysfile (piaojun)  
- mkfs.ocfs2: fix memory leak problems in main() (piaojun)  
- tunefs.ocfs2: fix memory leak problems in tunefs_journal_check() and parse_options() (piaojun)  
- o2image: fix a memory leak problem in ocfs2_image_free_bitmap() (piaojun)  
- debugfs.ocfs2: fix NULL pointer dereference risk in dump_dir_entry (Joseph Qi)  
- o2image: clean up unused variable 'install_flag' in o2image_initialize() (piaojun)  
- libocfs2: close fd if read fails in create_generation (Joseph Qi)  
- o2image: Free 'filepath' before return in prompt_image_creation() (Jun Piao)  
- libocfs2: fix risk of using uninitialized variables (Joseph Qi)  
- mkfs.ocfs2: fix command line segfault (Valentin Vidic)  
- debugfs.ocfs2: fix command line segfault (Valentin Vidic)  
- Update udev rule for newer kernels (Valentin Vidic)  
- ocfs2-tools: add support for vd devices (Valentin Vidić)  
- fsck.ocfs2: Free 'ci' in each cycle of for loop in check_journal_walk (Jun Piao)

* Fri Jul 08 2016 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-7.el6
- tools: obsolete ocfs2console (Junxiao Bi)

* Thu Jun 23 2016 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-6.el6
- vendor: rhel: remove redhat-lsb* dependency (Junxiao Bi)  
- scandisk: remove unnecessary scansysfs op (Junxiao Bi)

* Tue May 10 2016 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-5.el6
- o2cb: avoid useless loop when scan global hb disks (Junxiao Bi)

* Wed May 04 2016 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-4.el6
- tools: replace redhat-lsb dependency with redhat-lsb-core (Junxiao Bi)

* Mon Apr 11 2016 Tariq Saeed <tariq.x.saeed@oracle.com> - 1.8.6-3.el6
- o2cb: unable to start o2cb service on 2.6.18-xxx kernel. (Tariq Saeed)

* Tue Nov 24 2015 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-2.el6
- tools: up to 1.8.6-2 (Junxiao Bi)  
- ocfs2-tools: mount not showing fully resolved path (Srinivas Eeda)

* Wed Nov 18 2015 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.6-1
- mkfs.ocfs2: fix default slots number in man doc [Orabug 20443780]
- o2cb: fix systemd o2cb.service failure [Orabug 21071245]

* Tue Nov 03 2015 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.5
- ocfs2-tools: support trigger build from git
- fsck.ocfs2: fix corruption when truncate reflink file
- vendor: rhel7: add build/install dep pkg
- ocfs2-tools: support powerpath dev as heartbeat dev
- mounted.ocfs2: fix error checking
- o2cb: mount debugfs when load config
- o2cb: don't write sysconfig if status not changed
- ocfs2-tools: add systemd support
- ocfs2-tools: add build scripts for rhel7
- fsck.ocfs2: abort if fs is mounted
- fsck.ocfs2: fix journal tail wrapper
- Add check to compare journal size and cluster size
- fsck.ocfs2: do not remove the chain when verifying global bitmap chain alloc
- debugfs.ocfs2: Fix a bug in process_open_args()
- libo2dlm: Close file description after use
- debugfs.ocfs2: Fix memory leak problem in process_open_args() & main()

* Thu Jun 18 2015 Junxiao Bi <junxiao.bi@oracle.com> - 1.8.4
- cloned from git://oss.oracle.com/git/ocfs2-tools.git ocfs2-tools-1.8.4

